---
title: Document.execCommand()
slug: Web/API/Document/execCommand
tags:
  - API
  - DOM
  - Method
  - NeedsExample
  - Reference
  - editor
---
<div>{{ApiRef("DOM")}}{{Obsolete_header}}</div>

<p><span class="seoSummary">When an HTML document has been switched to <code><a href="/en-US/docs/Web/API/Document/designMode">designMode</a></code>, its <code>document</code> object exposes an <strong><code>execCommand</code></strong> method to run commands that manipulate the current editable region, such as <a href="/en-US/docs/Web/HTML/Element/input">form inputs</a> or <code><a href="/en-US/docs/Web/HTML/Global_attributes/contenteditable">contentEditable</a></code> elements.</span></p>

<p>Most commands affect the document's <a href="/en-US/docs/Web/API/Selection">selection</a> (bold, italics, etc.), while others insert new elements (adding a link), or affect an entire line (indenting). When using <code>contentEditable</code>, <code>execCommand()</code> affects the currently active editable element.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>document</var>.execCommand(<var>aCommandName</var>, <var>aShowDefaultUI</var>, <var>aValueArgument</var>)
</pre>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Boolean')}} that is <code>false</code> if the command is unsupported or disabled.</p>

<div class="note">
<p><strong>Note</strong>: <code><var>document</var>.execCommand()</code> only returns <code>true</code> if it is invoked as part of a user interaction. You can't use it to verify browser support before calling a command. From Firefox 82, nested <code>document.execCommand()</code> calls will always return <code>false</code>. </p>
</div>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>aCommandName</var></code></dt>
 <dd>A {{domxref("DOMString")}} specifying the name of the command to execute. See {{anch("Commands")}} for a list of possible commands.</dd>
 <dt><code><var>aShowDefaultUI</var></code></dt>
 <dd>A {{jsxref("Boolean")}} indicating whether the default user interface should be shown. This is not implemented in Mozilla.</dd>
 <dt><code><var>aValueArgument</var></code></dt>
 <dd>For commands which require an input argument, is a {{domxref("DOMString")}} providing that information. For example, <code>insertImage</code> requires the URL of the image to insert. Specify <code>null</code> if no argument is needed.</dd>
</dl>

<h3 id="Commands">Commands</h3>

<dl>
 <dt><code>backColor</code></dt>
 <dd>Changes the document background color. In <code>styleWithCss</code> mode, it affects the background color of the containing block instead. This requires a {{cssxref("&lt;color&gt;")}} value string to be passed in as a value argument. Note that Internet Explorer uses this to set the text background color.</dd>
 <dt><code>bold</code></dt>
 <dd>Toggles bold on/off for the selection or at the insertion point. Internet Explorer uses the {{HTMLElement("strong")}} tag instead of {{HTMLElement("b")}}.</dd>
 <dt><code>ClearAuthenticationCache</code></dt>
 <dd>Clears all authentication credentials from the cache.</dd>
 <dt><code>contentReadOnly</code></dt>
 <dd>Makes the content document either read-only or editable. This requires a boolean true/false as the value argument. (Not supported by Internet Explorer.)</dd>
 <dt><code>copy</code></dt>
 <dd>Copies the current selection to the clipboard. Conditions of having this behavior enabled vary from one browser to another, and have evolved over time. Check the compatibility table to determine if you can use it in your case.</dd>
 <dt><code>createLink</code></dt>
 <dd>Creates an hyperlink from the selection, but only if there is a selection. Requires a <a href="/en-US/docs/Archive/Mozilla/URIs_and_URLs">URI</a> string as a value argument for the hyperlink's <code>href</code>. The URI must contain at least a single character, which may be whitespace. (Internet Explorer will create a link with a <code>null</code> value.)</dd>
 <dt><code>cut</code></dt>
 <dd>Removes the current selection and copies it to the clipboard. When this behavior is enabled varies between browsers, and its conditions have evolved over time. Check <a href="#Browser_compatibility">the compatibility table</a> for usage details.</dd>
 <dt><code>decreaseFontSize</code></dt>
 <dd>Adds a {{HTMLElement("small")}} tag around the selection or at the insertion point. (Not supported by Internet Explorer.)</dd>
 <dt><code>defaultParagraphSeparator</code></dt>
 <dd>Changes the paragraph separator used when new paragraphs are created in editable text regions. See <a href="/en-US/docs/Web/Guide/HTML/Editable_content#Differences_in_markup_generation">Differences in markup generation</a> for more details.</dd>
 <dt><code>delete</code></dt>
 <dd>Deletes the current selection.</dd>
 <dt><code>enableAbsolutePositionEditor</code></dt>
 <dd>Enables or disables the grabber that allows absolutely-positioned elements to be moved around. The grabber is disabled by default since Firefox 64 ({{bug(1490641)}}).</dd>
 <dt><code>enableInlineTableEditing</code></dt>
 <dd>Enables or disables the table row/column insertion and deletion controls. The controls are disabled by default since Firefox 64 ({{bug(1490641)}}).</dd>
 <dt><code>enableObjectResizing</code></dt>
 <dd>Enables or disables the resize handles on images, tables, and absolutely-positioned elements and other resizable objects. The handles are disabled by default since Firefox 64 ({{bug(1490641)}}).</dd>
 <dt><code>fontName</code></dt>
 <dd>Changes the font name for the selection or at the insertion point. This requires a font name string (like <code>"Arial"</code>) as a value argument.</dd>
 <dt><code>fontSize</code></dt>
 <dd>Changes the font size for the selection or at the insertion point. This requires an integer from <code>1</code>-<code>7</code> as a value argument.</dd>
 <dt><code>foreColor</code></dt>
 <dd>Changes a font color for the selection or at the insertion point. This requires a hexadecimal color value string as a value argument.</dd>
 <dt><code>formatBlock</code></dt>
 <dd>Adds an HTML block-level element around the line containing the current selection, replacing the block element containing the line if one exists (in Firefox, {{HTMLElement("blockquote")}} is the exception — it will wrap any containing block element). Requires a tag-name string as a value argument. Virtually all block-level elements can be used. (Internet Explorer and Edge support only heading tags <code>H1</code>–<code>H6</code>, <code>ADDRESS</code>, and <code>PRE</code>, which must be wrapped in angle brackets, such as <code>"&lt;H1&gt;"</code>.)</dd>
 <dt><code>forwardDelete</code></dt>
 <dd>Deletes the character ahead of the <a href="http://en.wikipedia.org/wiki/Cursor_%28computers%29">cursor</a>'s position, identical to hitting the Delete key on a Windows keyboard.</dd>
 <dt><code>heading</code></dt>
 <dd>Adds a heading element around a selection or insertion point line. Requires the tag-name string as a value argument (i.e. <code>"H1"</code>, <code>"H6"</code>). (Not supported by Internet Explorer and Safari.)</dd>
 <dt><code>hiliteColor</code></dt>
 <dd>Changes the background color for the selection or at the insertion point. Requires a color value string as a value argument. <code>useCSS</code> must be <code>true</code> for this to function. (Not supported by Internet Explorer.)</dd>
 <dt><code>increaseFontSize</code></dt>
 <dd>Adds a {{HTMLElement("big")}} tag around the selection or at the insertion point. (Not supported by Internet Explorer.)</dd>
 <dt><code>indent</code></dt>
 <dd>Indents the line containing the selection or insertion point. In Firefox, if the selection spans multiple lines at different levels of indentation, only the least indented lines in the selection will be indented.</dd>
 <dt><code>insertBrOnReturn</code></dt>
 <dd>Controls whether the Enter key inserts a {{HTMLElement("br")}} element, or splits the current block element into two. (Not supported by Internet Explorer.)</dd>
 <dt><code>insertHorizontalRule</code></dt>
 <dd>Inserts a {{HTMLElement("hr")}} element at the insertion point, or replaces the selection with it.</dd>
 <dt><code>insertHTML</code></dt>
 <dd>Inserts an HTML string at the insertion point (deletes selection). Requires a valid HTML string as a value argument. (Not supported by Internet Explorer.)</dd>
 <dt><code>insertImage</code></dt>
 <dd>Inserts an image at the insertion point (deletes selection). Requires a URL string for the image's <code>src</code> as a value argument. The requirements for this string are the same as <code>createLink</code>.</dd>
 <dt><code>insertOrderedList</code></dt>
 <dd>Creates a <a href="/en-US/docs/Web/HTML/Element/ol">numbered ordered list</a> for the selection or at the insertion point.</dd>
 <dt><code>insertUnorderedList</code></dt>
 <dd>Creates a <a href="/en-US/docs/Web/HTML/Element/ul">bulleted unordered list</a> for the selection or at the insertion point.</dd>
 <dt><code>insertParagraph</code></dt>
 <dd>Inserts a <a href="/en-US/docs/Web/HTML/Element/p">paragraph</a> around the selection or the current line. (Internet Explorer inserts a paragraph at the insertion point and deletes the selection.)</dd>
 <dt><code>insertText</code></dt>
 <dd>Inserts the given plain text at the insertion point (deletes selection).</dd>
 <dt><code>italic</code></dt>
 <dd>Toggles italics on/off for the selection or at the insertion point. (Internet Explorer uses the {{HTMLElement("em")}} element instead of {{HTMLElement("i")}}.)</dd>
 <dt><code>justifyCenter</code></dt>
 <dd>Centers the selection or insertion point.</dd>
 <dt><code>justifyFull</code></dt>
 <dd>Justifies the selection or insertion point.</dd>
 <dt><code>justifyLeft</code></dt>
 <dd>Justifies the selection or insertion point to the left.</dd>
 <dt><code>justifyRight</code></dt>
 <dd>Right-justifies the selection or the insertion point.</dd>
 <dt><code>outdent</code></dt>
 <dd>Outdents the line containing the selection or insertion point.</dd>
 <dt><code>paste</code></dt>
 <dd>Pastes the clipboard contents at the insertion point (replaces current selection). Disabled for web content.</dd>
 <dt><code>redo</code></dt>
 <dd>Redoes the previous undo command.</dd>
 <dt><code>removeFormat</code></dt>
 <dd>Removes all formatting from the current selection.</dd>
 <dt><code>selectAll</code></dt>
 <dd>Selects all of the content of the editable region.</dd>
 <dt><code>strikeThrough</code></dt>
 <dd>Toggles strikethrough on/off for the selection or at the insertion point.</dd>
 <dt><code>subscript</code></dt>
 <dd>Toggles <a href="/en-US/docs/Web/HTML/Element/sub">subscript</a> on/off for the selection or at the insertion point.</dd>
 <dt><code>superscript</code></dt>
 <dd>Toggles <a href="/en-US/docs/Web/HTML/Element/sup">superscript</a> on/off for the selection or at the insertion point.</dd>
 <dt><code>underline</code></dt>
 <dd>Toggles <a href="/en-US/docs/Web/HTML/Element/u">underline</a> on/off for the selection or at the insertion point.</dd>
 <dt><code>undo</code></dt>
 <dd>Undoes the last executed command.</dd>
 <dt><code>unlink</code></dt>
 <dd>Removes the <a href="/en-US/docs/Web/HTML/Element/a">anchor element</a> from a selected hyperlink.</dd>
 <dt><code>useCSS</code> {{Deprecated_inline}}</dt>
 <dd>Toggles the use of HTML tags or CSS for the generated markup. Requires a boolean true/false as a value argument.</dd>
 <dd>NOTE: This argument is logically backwards (i.e. use <code>false</code> to use CSS, <code>true</code> to use HTML) and unsupported by Internet Explorer. This has been deprecated in favor of <code>styleWithCSS</code>.</dd>
 <dt><code>styleWithCSS</code></dt>
 <dd>Replaces the <code>useCSS</code> command. <code>true</code> modifies/generates <code>style</code> attributes in markup, false generates presentational elements.<br>
  </dd>
</dl>

<h2 id="Example">Example</h2>

<p>An example of <a href="https://codepen.io/chrisdavidmills/full/gzYjag/">how to use it</a> on CodePen.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td><a href="https://w3c.github.io/editing/docs/execCommand/">execCommand</a></td>
   <td>Unofficial Draft</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.execCommand")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("HTMLElement.contentEditable")}}</li>
 <li>{{domxref("document.designMode")}}</li>
 <li><a href="/en-US/docs/Rich-Text_Editing_in_Mozilla">Rich-Text Editing in Mozilla</a></li>
 <li><a href="https://github.com/guardian/scribe/blob/master/BROWSERINCONSISTENCIES.md">Scribe's "Browser Inconsistencies" documentation</a> with bugs related to <code>document.execCommand</code>.</li>
</ul>
